
// forward declarations
typedef struct FORCE_FIELD FORCE_FIELD;
typedef struct ATOM ATOM;
typedef struct CRYSTAL CRYSTAL;

FORCE_FIELD *build_force_field(int nat, ATOM *atoms, CRYSTAL *crystal, int verbose);

void evaluate_force_field(FORCE_FIELD *ff);
double collect_force_field(FORCE_FIELD *ff);
void delete_force_field(FORCE_FIELD *ff);

// access functions
void set_force_field_coordinates(FORCE_FIELD *ff, int n, double x, double y, double z);
void get_force_field_gradient(FORCE_FIELD *ff, int, double *gradx, double *grady, double *gradz);
int get_number_of_atoms(FORCE_FIELD *ff);
