#!/usr/bin/env python
from numpy import *

beta=10.0   # temperature parameter
orbital_energies=array([-2.0,-1.0,-1.0,-0.5,1.0,1.0,1.3,2.0]) # set of orbital energies
N=3 # number of electrons

def fermi(en,mu):
	# fermi-dirac distribution
	return 2.0/(1.0+exp(-beta*(mu-en)))
def func(mu):
	f=0.0
	for en in orbital_energies:
		f+=fermi(en,mu)
	return f-N 

# root determination by bisection
a=-10.0
b=10.0
dx=b-a
maxiter=1000
tolerance=1.0e-8

while (dx>tolerance):
	c=(b+a)/2.0
	print c
	if func(a)*func(c)<0:
		b,dx=c,b-a
	else:
		a,dx=c,b-a
else:
	print "Fermi level=",c,func(c)

# chemical potential = c
mu=c
occup=fermi(orbital_energies,mu)
for orb,occ in zip(orbital_energies,occup):
	print "orbital energy : ",orb," occupation : ",occ

